/*
 * boston_lcd.S
 *
 *  Created on: Feb 11, 2016
 *      Author: Chris.Risucci
 */
/*
Copyright (c) 2007-2018, MIPS Tech, LLC and/or its affiliated group companies or licensors

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other materials
provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be
used to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include <mips/asm.h>
#include <mips/regdef.h>
#include <core_config.h>

// Displays 8 characters to the 8 segmented LCD display
// NOTE: input must be 8 characters
// Example:
/*
.data

msg_boston:    .ascii "BOSTON  "

.text
LA  a0, msg_boston
bal     boston_lcd_display

*/


LEAF(boston_lcd_display)
	.set    push
	.set    noat
	LA  	$1, BOSTON_LCD_BASE
	lw      k1, 0(a0)
 	sw      k1, 0($1)
  	lw      k1, 4(a0)
  	sw      k1, 4($1)
  	sync
    .set    pop
	jr      ra
 END(boston_lcd_display)


// display a character in numbered segment in display
// int cpu_num
// char display_char
// boston_lcd_display_byte(cpu_num, display_char);

 LEAF(boston_lcd_display_byte)
	.set    push
	.set    noat
	LA  	$1, BOSTON_LCD_BASE
	ADDU	$1, $1, a0
 	sb      a1, 0($1)
 	sync
  	.set    pop
	jr      ra
 END(boston_lcd_display_byte)
