/* Sample test code for I6400 and I6500 (Coherent Processing System.)
 */
/*
Copyright (c) 2007-2018, MIPS Tech, LLC and/or its affiliated group companies or licensors

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other materials
provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be
used to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include <core_config.h>

// Global variables.
volatile int go_vp[24] ;		// used in start.S to synchronize boot
volatile int boot_count[24];
void boston_lcd_display_byte_ab(unsigned int, char);

#ifdef BOOT_LINUX
extern void(boot_linux(unsigned int));
#endif

//
// main():
// cpu_num is the number of the VP within the CPS
// 		core 	VP range
//    	0		0-3
//	  	1		4-7
//		2		8-11
//		3		12-15
//		4		15-19
//		5		20-23
//
//	core_num is the core number within the CPS (range 0-5)
//  vpe_num is the VP number within the executing core (range 0-3 NOTE: 2 is reserved)
//	num_vpe_this_core is the total number of VP within executing core
//
//
int main(unsigned int cpu_num, unsigned int core_num, unsigned int vpe_num, unsigned int num_vpe_this_core) {
    
	volatile int j;
    char display_char, blank;
    int temp;
#ifdef BOOT_LINUX
    void boot_linux(unsigned int);
    boot_linux(cpu_num);
#endif
    // End timing of boot for this "cpu".
    asm volatile ("mfc0 %[temp], $9": [temp] "=r"(temp) :) ;
    boot_count[cpu_num] = temp ;

    display_char = (char)(cpu_num + 0x30);   // ASCII char for cpu number.
    blank = (char)0x20;

    while (1) {
        boston_lcd_display_byte_ab(cpu_num, display_char);
        for (j = 0 ; j < (1000 * 10024) ; j++) {
        }
        boston_lcd_display_byte_ab(cpu_num, blank); // blank out display position for this "cpu".
        for (j = 0 ; j < (1000 * 10024) ; j++) {
        }

    }
    return 0 ;
}
