/*

Copyright (c) 2015-2019, Imagination Technologies Limited and/or its affiliated group companies

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other materials
provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be
used to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/




void ram_message();

// #ifdef SECONDCOPY

void copy_rom_2_ram(unsigned int *source_addr, unsigned int *destination_addr, unsigned int *end_addr) {

	while (destination_addr != end_addr) {

		*destination_addr = *source_addr;
		++destination_addr;
		++source_addr;
		}
	return;

}

// #endif

int rmain(unsigned int *source_addr, unsigned int *destination_addr, unsigned int *end_addr) {
	volatile int boot_count;
    int	temp;

    // End timing of boot for this "cpu".
    asm volatile ("mfc0 %[temp], $9": [temp] "=r"(temp) :);
    boot_count = temp;

// #ifdef SECONDCOPY
    copy_rom_2_ram(source_addr, destination_addr, end_addr);
// #endif
    ram_message();
    return 0 ;
}


