/*
 * init_gpr_64.S
*/
/*
Copyright (c) 2007-2018, MIPS Tech, LLC and/or its affiliated group companies or licensors

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list
of conditions and the following disclaimer in the documentation and/or other materials
provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be
used to endorse or promote products derived from this software without specific prior
written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include <mips/asm.h>
#include <core_config.h>
#include <mips/regdef.h>
#include <mips/m64c0.h>

	.set	noat                // Don't allow the assembler to use r1(at) for synthetic instr.
/**************************************************************************************
**************************************************************************************/
LEAF(init_gpr)

	// Initialize the general purpose registers and any shadow register sets.
	// Although not necessary, register initialization may be useful during boot,
    // debug, and simulation when certain ways of initializing registers may not work
    // (xor rN, rN, rN for example.)

	// Initialize register sets
    dli      $1, 0xdeadbeefdeadbeef      // (0xdeadbeefdeadbeef stands out, kseg2 mapped, odd.)

	daddu	$2, $0, $1
	daddu	$3, $0, $1
	daddu	$4, $0, $1
	daddu	$5, $0, $1
	daddu	$6, $0, $1
	daddu	$7, $0, $1
	daddu	$8, $0, $1
	daddu	$9, $0, $1
	daddu	$10, $0, $1
	daddu	$11, $0, $1
	daddu	$12, $0, $1
	daddu	$13, $0, $1
	daddu	$14, $0, $1
	daddu	$15, $0, $1
	daddu	$16, $0, $1
	daddu	$17, $0, $1
	daddu	$18, $0, $1
	daddu	$19, $0, $1
	daddu	$20, $0, $1
	daddu	$21, $0, $1
	daddu	$22, $0, $1
	daddu	$23, $0, $1
	daddu	$24, $0, $1
	daddu	$25, $0, $1
	daddu	$26, $0, $1
	daddu	$27, $0, $1
	daddu	$28, $0, $1
	daddu	$29, $0, $1
	daddu	$30, $0, $1
	// Don't overwrite $31 (ra)
    jalr    zero, ra
END(init_gpr)

